/* 
	Author 	: Thomas GIL (DotNetGuru.org)
	Date 	: 17 september 2006
	License : Public Domain
*/
using DotNetGuru.AspectDNG.Joinpoints;
using System;

public class AspectsSample{
	// Utility for pretty-print (write with some indentation)
	static string tab = "   ";
	private static void Write(int indent, string msg, params object[] info){
		for(int i=0; i<indent; i++) 
			Console.Write(tab);
		Console.WriteLine(msg, info);
	}

	private static int indent;

	[AroundCall("* Sample::Test(*)")]
	public static object YourMethodCallInterceptor(JoinPoint jp) {
		Write(++indent, "-> method call [{0}]", jp);
		object result = jp.Proceed();
		Write(indent--, "<- method call [{0}]", jp);
		return result;
	}

	[AroundCall("* Sample::.ctor(*)")]
	public static object YourConstructorCallInterceptor(JoinPoint jp) {
		Write(++indent, "-> constructor call [{0}]", jp);
		object result = jp.Proceed();
		Write(indent--, "<- constructor call [{0}]", jp);
		return result;
	}

	[AroundBody("* Sample::*Test(*)")]
	public static object YourMethodBodyInterceptor(JoinPoint jp) {
		Write(++indent, "-> method body [{0}]", jp);
		object result = jp.Proceed();
		Write(indent--, "<- method body [{0}]", jp);
		return result;
	}


    [AroundCall("*")]
    [AroundBody("*")]
    public static object Interceptor(OperationJoinPoint jp) {
        object result = jp.Proceed();
        return result;
    }
}
